--
--
-- Specializations Mouvement for MF 3080
-- @Autor Fendt413
-- @Date 25/12/09
--
--

Mouvement = {};

function Mouvement.prerequisitesPresent(specializations)
    return true
end;

function Mouvement:load(xmlFile)
	------- Fentre -------
	local rotationNodePartFenetre = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartFenetre#index"));
    if rotationNodePartFenetre ~= nil then
        self.rotationPartFenetre = {};
        self.rotationPartFenetre.node = rotationNodePartFenetre;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartFenetre#minRot"));
        self.rotationPartFenetre.minRot = {};
        self.rotationPartFenetre.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartFenetre.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartFenetre.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartFenetre#maxRot"));
        self.rotationPartFenetre.maxRot = {};
        self.rotationPartFenetre.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartFenetre.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartFenetre.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartFenetre.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartFenetre#rotTime"), 2)*1000;
        self.rotationPartFenetre.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartFenetre#touchRotLimit"), 10));
    end;  
	local rotationNodePartVerrinF = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartVerrinF#index"));
    if rotationNodePartVerrinF ~= nil then
        self.rotationPartVerrinF = {};
        self.rotationPartVerrinF.node = rotationNodePartVerrinF;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinF#minRot"));
        self.rotationPartVerrinF.minRot = {};
        self.rotationPartVerrinF.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinF.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinF.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinF#maxRot"));
        self.rotationPartVerrinF.maxRot = {};
        self.rotationPartVerrinF.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinF.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinF.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartVerrinF.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinF#rotTime"), 2)*1000;
        self.rotationPartVerrinF.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinF#touchRotLimit"), 10));
    end;  
	local translationPartNodeVerrinF = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPartVerrinF#index"));
    if translationPartNodeVerrinF ~= nil then
        self.translationPartVerrinF = {};
        self.translationPartVerrinF.node = translationPartNodeVerrinF;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartVerrinF#minTrans"));
        self.translationPartVerrinF.minTrans = {};
        self.translationPartVerrinF.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartVerrinF.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartVerrinF.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartVerrinF#maxTrans"));
        self.translationPartVerrinF.maxTrans = {};
        self.translationPartVerrinF.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartVerrinF.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartVerrinF.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPartVerrinF.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartVerrinF#transTime"), 2)*1000;
        self.translationPartVerrinF.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartVerrinF#touchTransLimit"), 10);
    end;
	
	------- Porte Gauche -------
	local rotationNodePartPorteG = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartPorteG#index"));
    if rotationNodePartPorteG ~= nil then
        self.rotationPartPorteG = {};
        self.rotationPartPorteG.node = rotationNodePartPorteG;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPorteG#minRot"));
        self.rotationPartPorteG.minRot = {};
        self.rotationPartPorteG.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPorteG.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPorteG.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPorteG#maxRot"));
        self.rotationPartPorteG.maxRot = {};
        self.rotationPartPorteG.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPorteG.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPorteG.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPorteG.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPorteG#rotTime"), 2)*1000;
        self.rotationPartPorteG.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPorteG#touchRotLimit"), 10));
    end;  
	local rotationNodePartVerrinG = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartVerrinG#index"));
    if rotationNodePartVerrinG ~= nil then
        self.rotationPartVerrinG = {};
        self.rotationPartVerrinG.node = rotationNodePartVerrinG;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinG#minRot"));
        self.rotationPartVerrinG.minRot = {};
        self.rotationPartVerrinG.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinG.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinG.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinG#maxRot"));
        self.rotationPartVerrinG.maxRot = {};
        self.rotationPartVerrinG.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinG.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinG.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartVerrinG.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinG#rotTime"), 2)*1000;
        self.rotationPartVerrinG.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinG#touchRotLimit"), 10));
    end;  
	------- Porte Droite -------
	local rotationNodePartPorteD = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartPorteD#index"));
    if rotationNodePartPorteD ~= nil then
        self.rotationPartPorteD = {};
        self.rotationPartPorteD.node = rotationNodePartPorteD;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPorteD#minRot"));
        self.rotationPartPorteD.minRot = {};
        self.rotationPartPorteD.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPorteD.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPorteD.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPorteD#maxRot"));
        self.rotationPartPorteD.maxRot = {};
        self.rotationPartPorteD.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPorteD.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPorteD.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPorteD.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPorteD#rotTime"), 2)*1000;
        self.rotationPartPorteD.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPorteD#touchRotLimit"), 10));
    end;  
	local rotationNodePartVerrinD = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartVerrinD#index"));
    if rotationNodePartVerrinD ~= nil then
        self.rotationPartVerrinD = {};
        self.rotationPartVerrinD.node = rotationNodePartVerrinD;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinD#minRot"));
        self.rotationPartVerrinD.minRot = {};
        self.rotationPartVerrinD.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinD.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinD.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinD#maxRot"));
        self.rotationPartVerrinD.maxRot = {};
        self.rotationPartVerrinD.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinD.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinD.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartVerrinD.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinD#rotTime"), 2)*1000;
        self.rotationPartVerrinD.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinD#touchRotLimit"), 10));
    end;  
---- Toit -------
	local rotationNodePartToit = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartToit#index"));
    if rotationNodePartToit ~= nil then
        self.rotationPartToit = {};
        self.rotationPartToit.node = rotationNodePartToit;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartToit#minRot"));
        self.rotationPartToit.minRot = {};
        self.rotationPartToit.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartToit.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartToit.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartToit#maxRot"));
        self.rotationPartToit.maxRot = {};
        self.rotationPartToit.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartToit.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartToit.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartToit.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartToit#rotTime"), 2)*1000;
        self.rotationPartToit.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartToit#touchRotLimit"), 10));
    end;  
	local rotationNodePartVerrinT = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartVerrinT#index"));
    if rotationNodePartVerrinT ~= nil then
        self.rotationPartVerrinT = {};
        self.rotationPartVerrinT.node = rotationNodePartVerrinT;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinT#minRot"));
        self.rotationPartVerrinT.minRot = {};
        self.rotationPartVerrinT.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinT.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinT.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartVerrinT#maxRot"));
        self.rotationPartVerrinT.maxRot = {};
        self.rotationPartVerrinT.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartVerrinT.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartVerrinT.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartVerrinT.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinT#rotTime"), 2)*1000;
        self.rotationPartVerrinT.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartVerrinT#touchRotLimit"), 10));
    end;  
	local translationPartNodeVerrinT = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPartVerrinT#index"));
    if translationPartNodeVerrinT ~= nil then
        self.translationPartVerrinT = {};
        self.translationPartVerrinT.node = translationPartNodeVerrinT;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartVerrinT#minTrans"));
        self.translationPartVerrinT.minTrans = {};
        self.translationPartVerrinT.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartVerrinT.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartVerrinT.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartVerrinT#maxTrans"));
        self.translationPartVerrinT.maxTrans = {};
        self.translationPartVerrinT.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartVerrinT.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartVerrinT.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPartVerrinT.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartVerrinT#transTime"), 2)*1000;
        self.translationPartVerrinT.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartVerrinT#touchTransLimit"), 10);
    end;

end;

function Mouvement:delete()
end;

function Mouvement:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Mouvement:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_8 then
		self.rotationMaxFenetre = not self.rotationMaxFenetre;
		self.rotationMaxVerrinF = not self.rotationMaxVerrinF;
		self.translationMaxVerrinF = not self.translationMaxVerrinF;
	end;
	if isDown and sym == Input.KEY_9 then
		self.rotationMaxToit = not self.rotationMaxToit;
		self.rotationMaxVerrinT = not self.rotationMaxVerrinT;
		self.translationMaxVerrinT = not self.translationMaxVerrinT;
	end;	
end;

function Mouvement:update(dt)
	local nearestDistance = 3.0; 
	local px, py, pz = getWorldTranslation(self.rotationPartPorteD.node);
	local vx, vy, vz = getWorldTranslation(Player.rootNode);
	local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
	if distance < nearestDistance then
		self.inrange = true; 
	else
		self.inrange = false; 
	end;
	if self.inrange then
		self.rotationMaxPorteD = true;
		self.rotationMaxVerrinD = true;
	else
		self.rotationMaxPorteD = false;
		self.rotationMaxVerrinD = false;
	end;
	
	local nearestDistance = 3.0; 
	local px, py, pz = getWorldTranslation(self.rotationPartPorteG.node);
	local vx, vy, vz = getWorldTranslation(Player.rootNode);
	local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
	if distance < nearestDistance then
		self.inrange = true; 
	else
		self.inrange = false; 
	end;
	if self.inrange then
		self.rotationMaxPorteG = true;
		self.rotationMaxVerrinG = true;
	else
		self.rotationMaxPorteG = false;
		self.rotationMaxVerrinG = false;
	end;
	------- Fentre -------
	if self.rotationPartFenetre ~= nil then
        local x, y, z = getRotation(self.rotationPartFenetre.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartFenetre.maxRot, self.rotationPartFenetre.minRot, 3, self.rotationPartFenetre.rotTime, dt, not self.rotationMaxFenetre);
        setRotation(self.rotationPartFenetre.node, unpack(newRot));
    end;
	if self.rotationPartVerrinF ~= nil then
        local x, y, z = getRotation(self.rotationPartVerrinF.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartVerrinF.maxRot, self.rotationPartVerrinF.minRot, 3, self.rotationPartVerrinF.rotTime, dt, not self.rotationMaxVerrinF);
        setRotation(self.rotationPartVerrinF.node, unpack(newRot));
    end;
	if self.translationPartVerrinF ~= nil then 
		local x, y, z = getTranslation(self.translationPartVerrinF.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPartVerrinF.maxTrans, self.translationPartVerrinF.minTrans, 3, self.translationPartVerrinF.transTime, dt, not self.translationMaxVerrinF); 
		setTranslation(self.translationPartVerrinF.node, unpack(newTrans)); 
	end;	
	------- Porte Gauche -------
	if self.rotationPartPorteG ~= nil then
        local x, y, z = getRotation(self.rotationPartPorteG.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartPorteG.maxRot, self.rotationPartPorteG.minRot, 3, self.rotationPartPorteG.rotTime, dt, not self.rotationMaxPorteG);
        setRotation(self.rotationPartPorteG.node, unpack(newRot));
    end;
	if self.rotationPartVerrinG ~= nil then
        local x, y, z = getRotation(self.rotationPartVerrinG.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartVerrinG.maxRot, self.rotationPartVerrinG.minRot, 3, self.rotationPartVerrinG.rotTime, dt, not self.rotationMaxVerrinG);
        setRotation(self.rotationPartVerrinG.node, unpack(newRot));
    end;

	------- Porte Droite -------
	if self.rotationPartPorteD ~= nil then
        local x, y, z = getRotation(self.rotationPartPorteD.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartPorteD.maxRot, self.rotationPartPorteD.minRot, 3, self.rotationPartPorteD.rotTime, dt, not self.rotationMaxPorteD);
        setRotation(self.rotationPartPorteD.node, unpack(newRot));
    end;
	if self.rotationPartVerrinD ~= nil then
        local x, y, z = getRotation(self.rotationPartVerrinD.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartVerrinD.maxRot, self.rotationPartVerrinD.minRot, 3, self.rotationPartVerrinD.rotTime, dt, not self.rotationMaxVerrinD);
        setRotation(self.rotationPartVerrinD.node, unpack(newRot));
    end;
	
	--------- Toit -------
	if self.rotationPartToit ~= nil then
        local x, y, z = getRotation(self.rotationPartToit.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartToit.maxRot, self.rotationPartToit.minRot, 3, self.rotationPartToit.rotTime, dt, not self.rotationMaxToit);
        setRotation(self.rotationPartToit.node, unpack(newRot));
    end;  	
	if self.rotationPartVerrinT ~= nil then
        local x, y, z = getRotation(self.rotationPartVerrinT.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartVerrinT.maxRot, self.rotationPartVerrinT.minRot, 3, self.rotationPartVerrinT.rotTime, dt, not self.rotationMaxVerrinT);
        setRotation(self.rotationPartVerrinT.node, unpack(newRot));
    end;
	if self.translationPartVerrinT ~= nil then 
		local x, y, z = getTranslation(self.translationPartVerrinT.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPartVerrinT.maxTrans, self.translationPartVerrinT.minTrans, 3, self.translationPartVerrinT.transTime, dt, not self.translationMaxVerrinT); 
		setTranslation(self.translationPartVerrinT.node, unpack(newTrans)); 
	end;	

end;

function Mouvement:draw()
end;
